{
       UAV Video Overlay for
     AutoProp8 autopilot program
               By
          earl@uphi.net
            05/11/09

All this code could be modified to be smaller and more efficient I'm sure.
I ain't a very good programer !

I had lots of help from the Prop forum.......

Used modified "HITT_Video_Overlay_012" object from HITT Consulting for OSD
Modified by earl@uphi.net

Look at the HITT_Video_Overlay_012 part of the program to get a feel for what you can
do with the OSD.

The original HITT_Video_Overlay_012 object has been modified for some special chacters.

 }
CON
  _clkmode        = xtal1 + pll8x ' Overlay Object works @ 40MHz ONLY!
  _xinfreq        = 5_000_000


OBJ
  Overlay    :  "HITT_Video_Overlay_012"
  ping       :  "ping"
  sn         :  "Simple_numbers"
  gps        :  "GPS_IO_mini_PNAV"                     
  ser        :  "FullDuplexSerial_mini"
  uart       :  "FullDuplexSerialPlus"
  uartDOF    :  "FullDuplexSerialPlusDOF"

VAR
  LONG temp,altitude,runningcount,ax,ay,az,gx,gy,gz
  byte rangeIN,gpsheading,speed,rxdof,cptr
  byte buffer [16]

PUB Start
  Overlay.init
  Overlay.SetMode(2)
  gps.start(8,9)                     ' start GPS ingest 
  uartDOF.start (22,23,0,115200)     ' start uart on pins 22,23 for 6DOF Atomic board

Init_Display
Display_OSD
Main


PUB Main

repeat

   Get6DOF                                  ' get the 6DOF data      


   Overlay.SetMode(4)
   overlay.moveto( 115,50)                  ' print Pitch    
   overlay.putstr(string("          "))
   overlay.moveto( 115,50)
   overlay.putStr(sn.dec(ax))
   overlay.moveto( 155,50)
   overlay.putStr(sn.dec((ax-500)/7*2))     ' Print Pitch in      Pitch centered at 500
   overlay.putchar(30)                      ' 2 degree increments   
                                    
       
   overlay.moveto( 145,66)                  ' print Roll 
   overlay.putstr(string("     "))
   overlay.moveto( 115,66)
   overlay.putStr(sn.dec(ay))
   overlay.moveto( 155,66)
   overlay.putStr(sn.dec((ay-510)/7*2))     ' Print Roll in       Roll centered at 510
   overlay.putchar(30)                      ' 2 degree increments    
                                    
   Overlay.SetMode(2)
       
   Display_OSD

PUB Init_Display

 overlay.moveto( 14,12)          ' Moveto's place cursor at position on OSD
 overlay.putstr(string("ALT"))
  
 overlay.moveto( 225,12)
 overlay.putstr(string("SPD"))

 overlay.moveto( 98,12)
 overlay.putstr(string("Compass"))

 overlay.moveto( 123,45)
 overlay.putchar(16)             ' up indicator
 overlay.moveto( 123,56)
 overlay.putchar(17)             ' down indicator

 overlay.moveto( 108,66)
 overlay.putchar(60)             ' left indicator
 overlay.moveto( 138,66)
 overlay.putchar(62)             ' right indicator

Overlay.SetMode(2)
 
PUB Display_OSD                 

     rangeIN := ping.Inches(10)  ' Get Range from ground In Inches via Ping device

     Overlay.SetMode(4)
     overlay.moveto( 116,153)
     overlay.putStrBig(string("    "))

   if  rangeIN < 60              ' If we are close to ground put on OSD
      overlay.moveto( 118,150)
      overlay.putStrBig(sn.dec(rangeIN))
      overlay.moveto( 65,185)
      overlay.putstr(string("Ground Getting Close"))  ' A little humor here !!!
       
   else                           ' If over 60 inches from ground don't clutter display
      overlay.moveto( 65,185)
      overlay.putstr(string("                     "))

   gps.altitude                    ' Get the alt from the gps unit
   altitude :=  (((uart.StrToDec(gps.altitude)/10) * 328)/100)   'Convert GPS meters string to desimal feet
   gps.heading                     ' Get the heading from the gps unit
   gpsheading := (uart.StrToDec(gps.heading))
   gps.speed                       ' Get the speed from the gps unit
   speed :=  (uart.StrToDec(gps.speed))

   overlay.moveto( 10,24)           ' Put the altitude on the OSD
   overlay.putStr(string("      "))             
   overlay.moveto( 10,24)
   overlay.putStr(sn.dec(altitude))

   overlay.moveto( 105,24)          ' Put the heading on the OSD 
   overlay.putStr(string("     "))             
   overlay.moveto( 115,24)
   overlay.putStr(sn.dec(gpsheading))            


   overlay.moveto( 230,24)          ' Put the speed on the OSD  
   overlay.putStr(string("   "))             
   overlay.moveto( 230,24)
   overlay.putStr(sn.dec(speed/10))            
   Overlay.SetMode(2)


PUB Get6DOF                            ' Get the 6DOF serial data

read6DOF                               ' Put the data in a buffer from 6DOF

  RunningCount := buffer[ 1]<<8 + buffer[ 2]  'Put buffer data into variables
  ax := buffer[ 3]<<8 + buffer[ 4]            'ax = acceleration
  ay := buffer[ 5]<<8 + buffer[ 6]
  az := buffer[ 7]<<8 + buffer[ 8]
  gx := buffer[ 9]<<8 + buffer[ 10]           'gx = gyro
  gy := buffer[ 11]<<8 + buffer[ 12]
  gz := buffer[ 13]<<8 + buffer[ 14]
  
PUB read6DOF

 Rxdof:=0                                 'initialize, so we know definitely what's in before checking content in the while
 repeat while Rxdof <> "A"                ' wait for the "A" to insure we are starting with
    Rxdof := uartdof.rxcheck

 cptr := 0                                ' zero the buffer pointer to start
 byte[ cptr++ ]:=Rxdof                    ' NOW the A is really in the buffer
 
 repeat while Rxdof <> "Z" and cptr < 16  ' continue to collect data until the end of sentence ("Z")
     Rxdof := uartdof.rx                  ' get character from uart Rx
     buffer[ cptr++ ] := Rxdof            ' save the character in the buff

      